function [MaskingEffects, fig]= Figure3_panel2_source(OutPutStruct) 
% Concatenating the means
M = [OutPutStruct.Means];
x = OutPutStruct(2).NumberOfBats;
x= x(x>1); % remove One bat
% Summary for One Bat
% OneBatIndS = find( [OutPutStruct.NumberOfBats] ==1 & strcmp([OutPutStruct.Paramter2],'NoMasking') );
% MeansOneBat = [OutPutStruct(OneBatIndS).Means]; 
% StdErrOneBat = [OutPutStruct(OneBatIndS).STDErrs];

MaskingEffects( numel(unique([OutPutStruct.Paramter1])) ) = ...
    struct('Mean_MaskEffect', [],...
    'StdRatio',[],...
    'NumberOfBats',[], ...
    'NumOfPreys', [], ...
    'ReceiverType', []);

RecVec = {  'CorrelationDetector', 'JAR_Corr'};
%  RecVec = { 'TimeSequenceTH', 'noFreq_Diff_CorrelationDetector', 'CorrelationDetector', ...
%      'JAR_Corr'};

% Summary for NoMask
NoMaskIndS  = find( strcmp([OutPutStruct.Paramter1],'NoMasking')); 
MeansNoMask = [OutPutStruct(NoMaskIndS).Means]; 
StdErrNoMask = [OutPutStruct(NoMaskIndS).STDErrs];
% rempve one bat
MeansNoMask = MeansNoMask(2:end);
StdErrNoMask = StdErrNoMask(2:end);

% figure prop
fig= figure();
ax1= gca;
hold on
ColVec = {'r', 'm', 'k', 'b'};

kk=1;
for kRec = RecVec
    IndS = find( strcmp([OutPutStruct.Paramter1],kRec)) ;
    [MeanR, StdR] = RatioCalc_MeansSTD(OutPutStruct, IndS, MeansNoMask, StdErrNoMask);
    
    % errobar
    errorbar(ax1, x ,MeanR, StdR, ...
            '-', 'Color', ColVec{kk}, ...
            'LineStyle', '-' , 'LineWidth',1.2) ; 
   
    % Output
    if ~isempty(MeanR)
        MaskingEffects(kk).Mean_MaskEffect = MeanR;
        MaskingEffects(kk).StdRatio =StdR;
        MaskingEffects(kk).NumOfPreys = OutPutStruct(IndS).Paramter2;
        MaskingEffects(kk).NumberOfBats = OutPutStruct(IndS).NumberOfBats ; % remove one bat
        MaskingEffects(kk).ReceiverType = OutPutStruct(IndS).Paramter1 ; % XXXX
    end % if ~~isempty(Corr2NoMask)
    kk=kk+1;
end  % for kRec = RecVec


set(fig,'Units','centimeters','Position',[ 2 2 6.5 6])
axis([0 22 -20 80]);
% title(ax1, 'Masking Effect')
Leg = legend('Peak Detector', 'Correlation: Same Freq',...
    'Correaltion: Random', 'JAR',  'Location', 'northwest');
Leg.FontSize = 7.5 ;
Leg.Position = [0.2    0.68    0.6    0.2];
Leg.Box ='off';

% ylabel(ax1, 'Masking Effect (%)');
xlabel('Number of Bats')
ax1.FontSize = 10;
legend 'off'
ax1.XTick = unique(x);


SaveFIGflag = 0;
if SaveFIGflag
    fig.PaperPositionMode = 'auto';
    FigPathName = 'C:\Users\DELL\Documents\\\\MATLAB Bat Simulation\Results\Final\Figures\Meta\Article\Final2\';
    FigName = 'ArtFig2b_20P_MaskingEffect_JAR_0701';
    print(fig,[FigPathName,FigName ],'-dmeta','-r0')
end % if SaveFIGflag
%
end
%%
% % % % 
% % % % % Summary for Correlation
% % % % CorrIndS = find( strcmp([OutPutStruct.Paramter1],'CorrelationDetector')) ;
% % % % [Corr2NoMask, CorrStdRtaio] = RatioCalc_MeansSTD(OutPutStruct, CorrIndS, MeansNoMask, StdErrNoMask);
% % % % 
% % % % % Summary for no FrequencyVariance
% % % % NoFreqDiffIndS = find( strcmp([OutPutStruct.Paramter1],'noFreq_Diff_CorrelationDetector')) ; % NoFreq_Diff_CorrelationDetector
% % % % [NoDiff2NoMask, NoDiffStdRtaio] = RatioCalc_MeansSTD(OutPutStruct, NoFreqDiffIndS, MeansNoMask, StdErrNoMask);
% % % % 
% % % % % Summary for Peak
% % % % PeakIndS = find( strcmp([OutPutStruct.Paramter1],'TimeSequenceTH') );                     
% % % % [Peak2NoMask, PeakStdRtaio] = RatioCalc_MeansSTD(OutPutStruct, PeakIndS, MeansNoMask, StdErrNoMask);
% % % % 
% % % % % Summary For JAR 
% % % % JARIndS = find( strcmp([OutPutStruct.Paramter1],'JAR_Corr') );
% % % % [JAR2NoMask,JARStdRtaio] = RatioCalc_MeansSTD(OutPutStruct, JARIndS, MeansNoMask, StdErrNoMask)
%%

%%
function [MaskEffect, RatioSTD] = RatioCalc_MeansSTD(OutPutStruct,IdStrct, MeansDen, STDDen)
MeansNum = [OutPutStruct(IdStrct).Means]; 
StdNum = [OutPutStruct(IdStrct).STDErrs];
RatioMeans = MeansNum ./ MeansDen;
MaskEffect = 100*(1-RatioMeans);
RatioSTD = 100 * RatioMeans .* ...
            sqrt( (StdNum.^2 ./ MeansNum.^2) + ...
            (STDDen.^2 / MeansDen.^2) ); %A/B * (sA/A + sB/B)
end
 %%
        
